# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AdminSourcesBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'description': 'str',
        'type_id': 'str',
        'created_at': 'datetime',
        'created_by': 'str',
        'last_updated_at': 'datetime',
        'last_updated_by': 'str',
        'config': 'object',
        'items_imported': 'int',
        'items_found': 'int',
        'last_import_started_at': 'datetime',
        'last_import_completed_at': 'datetime',
        'last_import_errors': 'list[str]',
        'project_id': 'str',
        '_global': 'bool',
        'icon_id': 'str'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'description': 'description',
        'type_id': 'typeId',
        'created_at': 'createdAt',
        'created_by': 'createdBy',
        'last_updated_at': 'lastUpdatedAt',
        'last_updated_by': 'lastUpdatedBy',
        'config': 'config',
        'items_imported': 'itemsImported',
        'items_found': 'itemsFound',
        'last_import_started_at': 'lastImportStartedAt',
        'last_import_completed_at': 'lastImportCompletedAt',
        'last_import_errors': 'lastImportErrors',
        'project_id': 'projectId',
        '_global': 'global',
        'icon_id': 'iconId'
    }

    def __init__(self, id=None, name=None, description=None, type_id=None, created_at=None, created_by=None, last_updated_at=None, last_updated_by=None, config=None, items_imported=None, items_found=None, last_import_started_at=None, last_import_completed_at=None, last_import_errors=None, project_id=None, _global=None, icon_id=None):  # noqa: E501
        """AdminSourcesBody - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._description = None
        self._type_id = None
        self._created_at = None
        self._created_by = None
        self._last_updated_at = None
        self._last_updated_by = None
        self._config = None
        self._items_imported = None
        self._items_found = None
        self._last_import_started_at = None
        self._last_import_completed_at = None
        self._last_import_errors = None
        self._project_id = None
        self.__global = None
        self._icon_id = None
        self.discriminator = None
        if id is not None:
            self.id = id
        self.name = name
        if description is not None:
            self.description = description
        self.type_id = type_id
        if created_at is not None:
            self.created_at = created_at
        if created_by is not None:
            self.created_by = created_by
        if last_updated_at is not None:
            self.last_updated_at = last_updated_at
        if last_updated_by is not None:
            self.last_updated_by = last_updated_by
        self.config = config
        if items_imported is not None:
            self.items_imported = items_imported
        if items_found is not None:
            self.items_found = items_found
        if last_import_started_at is not None:
            self.last_import_started_at = last_import_started_at
        if last_import_completed_at is not None:
            self.last_import_completed_at = last_import_completed_at
        if last_import_errors is not None:
            self.last_import_errors = last_import_errors
        if project_id is not None:
            self.project_id = project_id
        if _global is not None:
            self._global = _global
        if icon_id is not None:
            self.icon_id = icon_id

    @property
    def id(self):
        """Gets the id of this AdminSourcesBody.  # noqa: E501

        Catalog Source id  # noqa: E501

        :return: The id of this AdminSourcesBody.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AdminSourcesBody.

        Catalog Source id  # noqa: E501

        :param id: The id of this AdminSourcesBody.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this AdminSourcesBody.  # noqa: E501

        Catalog Source name  # noqa: E501

        :return: The name of this AdminSourcesBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this AdminSourcesBody.

        Catalog Source name  # noqa: E501

        :param name: The name of this AdminSourcesBody.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this AdminSourcesBody.  # noqa: E501

        Catalog Source description  # noqa: E501

        :return: The description of this AdminSourcesBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this AdminSourcesBody.

        Catalog Source description  # noqa: E501

        :param description: The description of this AdminSourcesBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def type_id(self):
        """Gets the type_id of this AdminSourcesBody.  # noqa: E501

        Type of source, e.g. blueprint, CFT... etc  # noqa: E501

        :return: The type_id of this AdminSourcesBody.  # noqa: E501
        :rtype: str
        """
        return self._type_id

    @type_id.setter
    def type_id(self, type_id):
        """Sets the type_id of this AdminSourcesBody.

        Type of source, e.g. blueprint, CFT... etc  # noqa: E501

        :param type_id: The type_id of this AdminSourcesBody.  # noqa: E501
        :type: str
        """
        if type_id is None:
            raise ValueError("Invalid value for `type_id`, must not be `None`")  # noqa: E501

        self._type_id = type_id

    @property
    def created_at(self):
        """Gets the created_at of this AdminSourcesBody.  # noqa: E501

        Creation time  # noqa: E501

        :return: The created_at of this AdminSourcesBody.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this AdminSourcesBody.

        Creation time  # noqa: E501

        :param created_at: The created_at of this AdminSourcesBody.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def created_by(self):
        """Gets the created_by of this AdminSourcesBody.  # noqa: E501

        Created By  # noqa: E501

        :return: The created_by of this AdminSourcesBody.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this AdminSourcesBody.

        Created By  # noqa: E501

        :param created_by: The created_by of this AdminSourcesBody.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def last_updated_at(self):
        """Gets the last_updated_at of this AdminSourcesBody.  # noqa: E501

        Update time  # noqa: E501

        :return: The last_updated_at of this AdminSourcesBody.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated_at

    @last_updated_at.setter
    def last_updated_at(self, last_updated_at):
        """Sets the last_updated_at of this AdminSourcesBody.

        Update time  # noqa: E501

        :param last_updated_at: The last_updated_at of this AdminSourcesBody.  # noqa: E501
        :type: datetime
        """

        self._last_updated_at = last_updated_at

    @property
    def last_updated_by(self):
        """Gets the last_updated_by of this AdminSourcesBody.  # noqa: E501

        Updated By  # noqa: E501

        :return: The last_updated_by of this AdminSourcesBody.  # noqa: E501
        :rtype: str
        """
        return self._last_updated_by

    @last_updated_by.setter
    def last_updated_by(self, last_updated_by):
        """Sets the last_updated_by of this AdminSourcesBody.

        Updated By  # noqa: E501

        :param last_updated_by: The last_updated_by of this AdminSourcesBody.  # noqa: E501
        :type: str
        """

        self._last_updated_by = last_updated_by

    @property
    def config(self):
        """Gets the config of this AdminSourcesBody.  # noqa: E501


        :return: The config of this AdminSourcesBody.  # noqa: E501
        :rtype: object
        """
        return self._config

    @config.setter
    def config(self, config):
        """Sets the config of this AdminSourcesBody.


        :param config: The config of this AdminSourcesBody.  # noqa: E501
        :type: object
        """
        if config is None:
            raise ValueError("Invalid value for `config`, must not be `None`")  # noqa: E501

        self._config = config

    @property
    def items_imported(self):
        """Gets the items_imported of this AdminSourcesBody.  # noqa: E501

        Number of items imported.  # noqa: E501

        :return: The items_imported of this AdminSourcesBody.  # noqa: E501
        :rtype: int
        """
        return self._items_imported

    @items_imported.setter
    def items_imported(self, items_imported):
        """Sets the items_imported of this AdminSourcesBody.

        Number of items imported.  # noqa: E501

        :param items_imported: The items_imported of this AdminSourcesBody.  # noqa: E501
        :type: int
        """

        self._items_imported = items_imported

    @property
    def items_found(self):
        """Gets the items_found of this AdminSourcesBody.  # noqa: E501

        Number of items found  # noqa: E501

        :return: The items_found of this AdminSourcesBody.  # noqa: E501
        :rtype: int
        """
        return self._items_found

    @items_found.setter
    def items_found(self, items_found):
        """Sets the items_found of this AdminSourcesBody.

        Number of items found  # noqa: E501

        :param items_found: The items_found of this AdminSourcesBody.  # noqa: E501
        :type: int
        """

        self._items_found = items_found

    @property
    def last_import_started_at(self):
        """Gets the last_import_started_at of this AdminSourcesBody.  # noqa: E501

        Last import start time  # noqa: E501

        :return: The last_import_started_at of this AdminSourcesBody.  # noqa: E501
        :rtype: datetime
        """
        return self._last_import_started_at

    @last_import_started_at.setter
    def last_import_started_at(self, last_import_started_at):
        """Sets the last_import_started_at of this AdminSourcesBody.

        Last import start time  # noqa: E501

        :param last_import_started_at: The last_import_started_at of this AdminSourcesBody.  # noqa: E501
        :type: datetime
        """

        self._last_import_started_at = last_import_started_at

    @property
    def last_import_completed_at(self):
        """Gets the last_import_completed_at of this AdminSourcesBody.  # noqa: E501

        Last import completion time  # noqa: E501

        :return: The last_import_completed_at of this AdminSourcesBody.  # noqa: E501
        :rtype: datetime
        """
        return self._last_import_completed_at

    @last_import_completed_at.setter
    def last_import_completed_at(self, last_import_completed_at):
        """Sets the last_import_completed_at of this AdminSourcesBody.

        Last import completion time  # noqa: E501

        :param last_import_completed_at: The last_import_completed_at of this AdminSourcesBody.  # noqa: E501
        :type: datetime
        """

        self._last_import_completed_at = last_import_completed_at

    @property
    def last_import_errors(self):
        """Gets the last_import_errors of this AdminSourcesBody.  # noqa: E501

        Last import error(s)  # noqa: E501

        :return: The last_import_errors of this AdminSourcesBody.  # noqa: E501
        :rtype: list[str]
        """
        return self._last_import_errors

    @last_import_errors.setter
    def last_import_errors(self, last_import_errors):
        """Sets the last_import_errors of this AdminSourcesBody.

        Last import error(s)  # noqa: E501

        :param last_import_errors: The last_import_errors of this AdminSourcesBody.  # noqa: E501
        :type: list[str]
        """

        self._last_import_errors = last_import_errors

    @property
    def project_id(self):
        """Gets the project_id of this AdminSourcesBody.  # noqa: E501

        Project id where the source belongs  # noqa: E501

        :return: The project_id of this AdminSourcesBody.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this AdminSourcesBody.

        Project id where the source belongs  # noqa: E501

        :param project_id: The project_id of this AdminSourcesBody.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def _global(self):
        """Gets the _global of this AdminSourcesBody.  # noqa: E501

        Global flag indicating that all the items can be requested across all projects.  # noqa: E501

        :return: The _global of this AdminSourcesBody.  # noqa: E501
        :rtype: bool
        """
        return self.__global

    @_global.setter
    def _global(self, _global):
        """Sets the _global of this AdminSourcesBody.

        Global flag indicating that all the items can be requested across all projects.  # noqa: E501

        :param _global: The _global of this AdminSourcesBody.  # noqa: E501
        :type: bool
        """

        self.__global = _global

    @property
    def icon_id(self):
        """Gets the icon_id of this AdminSourcesBody.  # noqa: E501

        Default Icon Id  # noqa: E501

        :return: The icon_id of this AdminSourcesBody.  # noqa: E501
        :rtype: str
        """
        return self._icon_id

    @icon_id.setter
    def icon_id(self, icon_id):
        """Sets the icon_id of this AdminSourcesBody.

        Default Icon Id  # noqa: E501

        :param icon_id: The icon_id of this AdminSourcesBody.  # noqa: E501
        :type: str
        """

        self._icon_id = icon_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AdminSourcesBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AdminSourcesBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
